# Clause d'apparition d'action

## Apparition selon la position du viseur actuel dans le circuit de visa/signature

### Apparition de l'action tant qu'il existe un viseur suivant dans ce circuit de visa

~~~ sql
res_id in (SELECT li.res_id
FROM listinstance li
WHERE li.difflist_type = 'VISA_CIRCUIT'
  AND li.item_mode = 'visa'
  AND li.process_date IS NULL
  AND EXISTS (
      SELECT 1
      FROM listinstance next_li
      WHERE next_li.res_id = li.res_id
        AND next_li.item_mode = 'visa'
        AND next_li.sequence > li.sequence
 ))
~~~

### Apparition de l'action pour le dernier viseur dans ce circuit de visa/signature

~~~ sql
status <> 'PSIG' and res_id in (SELECT li.res_id
FROM listinstance li
WHERE li.difflist_type = 'VISA_CIRCUIT'
  AND li.item_mode = 'visa'
  AND li.process_date IS NULL
  AND NOT EXISTS (
      SELECT 1
      FROM listinstance prev_li
      WHERE prev_li.res_id = li.res_id
        AND prev_li.item_mode = 'visa'
        AND prev_li.sequence < li.sequence
        AND prev_li.process_date IS NULL
  )
  AND NOT EXISTS (
      SELECT 1
      FROM listinstance next_li
      WHERE next_li.res_id = li.res_id
        AND next_li.item_mode = 'visa'
        AND next_li.sequence > li.sequence
 ))
~~~