# Message d'erreur

## Afficher les traces réseau depuis le navigateur

Pour trouver l'origine d'un dysfonctionnement :

commencer par activer la console réseau de votre navigateur en appuyant sur la touche F12,
cliquer sur l'onglet reseau (vider (en cliquant sur la poubelle) avant de lancer l'action qui bug)
cliquer sur la ligne réseau impactée par le bug
aller sur la réponse pour visualiser l'erreur.
![](\howto.doc\img\debug_browser.png)

## Les logs d'Apache

Un complément d'informations utiles est également consultable depuis les logs d'Apache. Par défaut, vous les trouvez dans :

```/var/log/apache2/error.log
```

## Mode debug

Pour aider à trouver l'origine du bug, voici les fichiers à paramétrer pour passer en mode debug depuis les fichiers de paramétrage technique.

### Exemple pour Maarch Courrier.

./MaarchCourrier/custom/cs_moncustom/apps/maarch_entreprise/xml/config.xml

```<debug>true</debug>```

./MaarchCourrier/custom/cs_moncustom/apps/maarch_entreprise/xml/log4php.xml

~~~ linux
<root>
    <level value="DEBUG" />
    <appender_ref ref="fonctionnel,technique" />
</root>
<logger name="loggerFonctionnel" additivity="true">
    <level value="DEBUG" />
    <appender_ref ref="appenderFonctionnel" />
</logger>
<logger name="loggerTechnique" additivity="true">
    <level value="DEBUG" />
    <appender_ref ref="appenderTechnique" />
</logger>
~~~

### Exemple pour Maarch Capture :

./MaarchCapture/config/Capture.xml

~~~ linux
<workflow name="MAARCH_SCAN_TO_MC" debug="true" logMode="Maarch" maarchLogParam="/var/www/html/MaarchCourrier/apps/maarch_entreprise/xml/log4php.xml" maarchLoggerName="loggerTechnique">
~~~