# Analyse de bug

[Afficher les traces réseau depuis le navigateur](## Afficher les traces réseau depuis le navigateur)

[Les logs de PHP](## Les logs de PHP)

[Les logs d'Apache](## Les logs d'Apache)

[Mode debug](## Mode debug) 

[Déclaration d'un ticket dans la forge](## Déclaration d'un ticket dans la forge)

## Afficher les traces réseau depuis le navigateur

Pour trouver l'origine d'un dysfonctionnement  :

- commencer par activer la console réseau de votre navigateur en appuyant sur la touche F12,
- cliquer sur l'onglet reseau (vider (en cliquant sur la poubelle) avant de lancer l'action qui bug)
- cliquer sur la ligne réseau impactée par le bug 
- aller sur la réponse pour visualiser l'erreur.

![Debug navigateur](img/debug_browser.png)

## Les logs de PHP

Si le fichier php_errors.log est vide ou n'existe pas (le résultat de la recherche ci-dessous est vide) :

```ini
root@MaarchIntegration1810:/# find . -name "php_errors.log" 2>/dev/null
```

Alors il faudra modifier les fichiers de configuration de php afin d'activer la log pour pouvoir diagnostiquer la source du dysfonctionnement :

Pour activer la log il faut modifier les fichiers : php.ini qui peut être aux emplacements suivants : 

- /etc/php/NUM_VERSION/apache2/php.ini
- /etc/php/NUM_VERSION/cli/php.ini

```ini
display_errors = On
error_log = php_errors.log
```

L'attribut de configuration error_log = php_errors.log va permettre de créer un fichier de log php_errors.log à la racine de votre logiciel, lorsqu'une erreur va apparaître.

## Les logs d'Apache

Un complément d'informations utiles est également consultable depuis les logs d'Apache. Par défaut, vous les trouvez dans :

```bash
/var/log/apache2/error.log
```

## Mode debug 

Pour aider à trouver l'origine du bug, voici les fichiers à paramétrer pour passer en mode debug depuis les fichiers de paramétrage technique.

**Exemple pour Maarch Courrier.**

- ./MaarchCourrier/custom/cs_moncustom/apps/maarch_entreprise/xml/config.xml

```xml
    <debug>true</debug>
```

- ./MaarchCourrier/custom/cs_moncustom/apps/maarch_entreprise/xml/log4php.xml

```xml
    <root>
        <level value="DEBUG" />
        <appender_ref ref="fonctionnel,technique" />
    </root>
    <logger name="loggerFonctionnel" additivity="true">
        <level value="DEBUG" />
        <appender_ref ref="appenderFonctionnel" />
    </logger>
    <logger name="loggerTechnique" additivity="true">
        <level value="DEBUG" />
        <appender_ref ref="appenderTechnique" />
    </logger>
```

**Exemple pour Maarch Capture :**

- ./MaarchCapture/config/Capture.xml

```xml
    <workflow name="MAARCH_SCAN_TO_MC" debug="true" logMode="Maarch" maarchLogParam="/var/www/html/MaarchCourrier/apps/maarch_entreprise/xml/log4php.xml" maarchLoggerName="loggerTechnique">
```


**Exemple pour Maarch RM :**

- ./laabs/data/maarchRM/conf/configuration.ini

```ini
; Log events in Laabs log
; 0 = no trace
; 1 = trace only errors
; 2 = trace queries
; 3 = dump queries
trace = 3
```

## Déclaration d'un ticket dans la forge

Si un bug est avéré, il faut le déclarer dans la forge maarch :

https://forge.maarch.org
