# Mises à jour manuelle


**Avant toute mise à jour, pensez à faire une sauvegarde de votre répertoire maarch** 


## Maarch capture

Bien se positionner dans le **répertoire racine** de maarch capture : 

```
/opt/maarch/MaarchCapture# git status

/opt/maarch/MaarchCapture# git config core.fileMode false (si le git status donne une longue liste de modif : les chown/chmod de fichiers par exemple)

/opt/maarch/MaarchCapture# git stash (optionel : s'il y a eu des modifications importantes)

/opt/maarch/MaarchCapture# git fetch

/opt/maarch/MaarchCapture# git branch

/opt/maarch/MaarchCapture# git checkout -b 1.5 tags/1.5

/opt/maarch/MaarchCapture# git status

```

Vérifiez que les dossiers/fichiers mis à jour ont les bons droits et le bon utilisateur. 

En cas de messages avec des fichiers au debut, faire un git chekout des fichiers

## Maarch courrier

Bien se positionner dans le **répertoire racine** de maarch courrier : 

```
/var/www/html/MaarchCourrier# git status

/var/www/html/MaarchCourrier# git config core.fileMode false (si le git status donne une longue liste de modif : les chown/chmod de fichiers par exemple)

/var/www/html/MaarchCourrier# git stash  (optionel : s'il y a eu des modifications importantes)

/var/www/html/MaarchCourrier# git fetch

/var/www/html/MaarchCourrier# git branch

/var/www/html/MaarchCourrier# git checkout -b 18.10.10 tags/18.10.10

/var/www/html/MaarchCourrier# git status

/var/www/html/MaarchCourrier# git stash apply (optionel : s'il y a eu des modifications importantes)
```
Vérifiez que les dossiers/fichiers mis à jour ont les bons droits et le bon utilisateur.


# Commandes git utiles  

Les commandes git les plus utilisées sont : 

* Récuperer le dernier tag

```
git fetch 
```

* Checkout le dernier tag

```
git checkout $latestTag

```

* Avoir le dernier tag de la branche actuelle

```
git describe --abbrev=0 --tags
```

* Parcourir de toutes les branches et mettre à jour

```
for b in "git branch -r | grep -v -- '->'"; do git branch --track ${b##origin/} $b; done
for b in "git branch -r | grep -v -- '->'"; do echo $b; done

branches=()
eval "$(git for-each-ref --shell --format='branches+=(%(refname))' refs/heads/)"
for branch in "${branches[@]}"; do
    echo $branch
done
```


