# Connecteur Pastell

*Lien du drive : https://drive.google.com/drive/folders/1ipY7_qMARqER0xBhwt7OjkNHgxVeFylj?usp=drive_link*

## 🎯Objectif

L’objectif de cette procédure est de répertorier les informations Pastell nécessaires à l’installation du connecteur ainsi que les subtilités rencontrées à l’échelle de la chefferie de projet.

## 📋Information du XML nécessaires

- **Id** : pastell
- **login** : identifiant du compte pastell servant à l’interconnexion
- **password** : Mot de passe du compte client (à intégrer dans passbolt pour le communiquer au tech
- **url** : url pastell du client
- **entityId** : Identifiant de l’entité a pointé dans pastell
- **connectorId** : Identifiant du connecteur à utiliser dans pastell
- **documentType** : ls-document-pdf
- **iParapheurType** : Type à utiliser dans pastell
- **iParapheurSousType** : Sous-type de référence à utiliser dans pastell
- **errorCode** : KO
- **visaState** : CachetOK
- **signState** : Signe
- **refusedVisa** : RejetVisa
- **refusedSign** : RejetSignataire

## 📋 Procédure d'installation

**1. Id**

L’identifiant sera toujours “Pastell”. C’est une information en dur, écrite dans le fichier technique (XML) qui ne change pas.

**2. Login & password**

A demander au client. Ce login et mot de passe identifient l’utilisateur utilisé par Maarch Courrier pour se connecter à Pastell.

Il est nécessaire que cet utilisateur ait accès aux différents types, sous type, bureau que le client souhaite utiliser dans Maarch.

**3. Url**

A demander au client. C’est l’url d’accès à la plateforme pastell du client.

*Exemple : https://pastell.partenaire.libriciel.fr/*

**4. EntityId**

A demander au client. C’est l’identifiant indiquant l’entité portant le connecteur Parapheur dans pastell.

**ATTENTION**, doit être utilisé l’identifiant de l’entité fille

Le client le retrouve dans l’administration des entités de Pastell

![@](img/Pastel1.png)

**5. ConnectorId**

A demander au client. C’est l’identifiant indiquant le connecteur à utiliser dans pastell. Ici c’est le connecteur vers Iparapheur.

Le client le retrouve dans l’administration de son connecteur dans l’URL de la page.

![@](img/Pastel2.png)

![@](img/Pastel3.png)

**6. Document Type**

A vérifier par le client. L’identifiant sera toujours “ls-document-pdf”. Il faut demander au client de vérifier son existence et son attribution au connecteur.

Le client le retrouve dans l’administration des types de dossier

![@](img/Pastel4.png)

**7. iParapheurType & iParapheurSousType**

A demander au client. Ce sont les types et sous type intégrés par défaut lors de l’envoi du document dans Pastell par Maarch Courrier

**ATTENTION,** le sous-type et types indiqué doivent être existant dans pastell.

**ATTENTION**, les sous-type envoyés dans Pastell correspondent à l’identifiant de l’utilisateur MAARCH suivant dans le circuit**.**

*Exemple : Circuit de visa :*

![@](img/Pastel5.png)

Le sous-type envoyé dans pastell sera l’identifiant de Bernard blier : bblier.

Il est nécessaire que ce sous-type (bblier) soit existant dans Pastell - Iparapheur.

Le client le retrouve dans l’administration du connecteur

![@](img/Pastel6.png)

**8. errorCode - visaState - signState - refusedVisa - refusedSign**

Ce sont des informations en dur écrites dans le fichier technique (XML) qui ne changent pas.

**SignState =** A e-envoyer - EENV

**Refused Visa =** Signature refusée sur la tablette (MP) - REJ_SIGN

**RefusedSign =** Signature refusée sur la tablette (MP) - REJ_SIGN