**Les variables Globales de filre** ( à mettre sur les champs de type date )
 
 * $__timeFilter(creation_date) : Permet de filtrer les résultats de la requête en fonction de la période choisie
 * $__timeGroup(creation_date,1d) : Permet de regrouper les resultat par seconde (1s), par jour ( 1d ), par semaine (1w), par mois (1m), par année (1y) 
 
 
**Tableau des champs de la base de données qui ont servi au calcul des indicateurs**

| **Indicateurs**                                         | **Champs**                                                                                                                               | **Requêtes SQL associées**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
|---------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| Filtrage des courriers par modèle de courriers          | - indexing_models.label<br>- indexing_models.id<br>- res_letterbox.destination<br>- res_letterbox.type_id                                | SELECT<br>  indexing_models.label AS "Modèle d'enregistrement",<br>  count(res_letterbox.res_id) AS "Nombre de courriers"<br>FROM res_letterbox, entities,indexing_models<br>WHERE <br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND indexing_models.id = res_letterbox.model_id<br>  AND res_letterbox.destination = entities.entity_id<br>  AND res_letterbox.model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>GROUP BY indexing_models.label<br>ORDER BY 2 desc                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| Filtrage des courriers par priorité                     | - priorities.label<br>- res_letterbox.destination<br>- priorities.id<br>- res_letterbox.priority<br>- res_letterbox.model_id             | SELECT<br>  priorities.label AS "Priorités",<br>  count(res_letterbox.res_id) AS "Nombre de courriers"<br>FROM res_letterbox, entities,priorities<br>WHERE <br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND res_letterbox.destination = entities.entity_id<br>  AND priorities.id = res_letterbox.priority<br>GROUP BY priorities.label<br>ORDER BY 2 desc                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| Filtrage des courriers par entité                       | - res_letterbox.destination<br>- entities.entity_id<br>- res_letterbox.creation_date                                                     | SELECT<br>  entities.entity_label AS "Entités",<br>  count(res_letterbox.res_id) AS "Nombre de courriers"<br>FROM res_letterbox, entities<br>WHERE <br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND res_letterbox.destination = entities.entity_id<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>GROUP BY res_letterbox.destination,entities.entity_label<br>ORDER BY 2 desc                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| Filtrage des courriers par typologie                    | - res_letterbox.type_id<br>- doctypes.type_id<br>- res_letterbox.creation_date                                                           | SELECT<br>  doctypes.description AS "Typologie",<br>  count(res_letterbox.res_id) AS "Nombre de courriers"<br>FROM res_letterbox, entities,doctypes<br>WHERE <br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>   AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND res_letterbox.destination = entities.entity_id<br>  AND doctypes.type_id = res_letterbox.type_id <br>GROUP BY doctypes.description<br>ORDER BY 2 desc                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| Filtrage des courriers par statut                       | - res_letterbox.status<br>- status.id<br>- res_letterbox.creation_date                                                                   | SELECT<br>  status.label_status AS "Status",<br>  count(res_letterbox.res_id) AS "Nombre de courriers"<br>FROM res_letterbox, entities,doctypes,status<br>WHERE <br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND res_letterbox.status IN (SELECT id FROM status WHERE label_status IN ($Statuts))<br>  AND res_letterbox.destination = entities.entity_id<br>  AND doctypes.type_id = res_letterbox.type_id<br>  AND status.id = res_letterbox.status<br>GROUP BY status.label_status<br>ORDER BY 2 desc                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| Nombre de courriers Total                               | - res_letterbox.res_id<br>- res_letterbox.creation_date                                                                                  | SELECT<br>  creation_date AS "time",<br>  res_id AS "Nombre de courriers Total"<br>FROM res_letterbox<br>WHERE <br>  $__timeFilter(creation_date)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| Nombre de courriers total des modèles sélectionnés      | - res_letterbox.model_id                                                                                                                 | SELECT<br>  creation_date AS "time",<br>  res_id AS "Courriers des entités : $entity_label"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date) <br>  AND res_letterbox.model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>GROUP BY 1, res_id<br>ORDER BY 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| Nombre de courriers total des priorités sélectionnées   | - res_letterbox.priority                                                                                                                 | SELECT<br>  creation_date AS "time",<br>  res_id AS "Courriers des entités : $entity_label"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date) <br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>GROUP BY 1, res_id<br>ORDER BY 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| Nombre de courriers total des entités sélectionnées     | - res_letterbox.model_id<br>- res_letterbox.priority<br>- res_letterbox.destination                                                      | SELECT<br>  creation_date AS "time",<br>  res_id AS "Courriers des entités : $entity_label"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date) <br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>GROUP BY 1, res_id<br>ORDER BY 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| Nombre de courriers total des types sélectionnés        | - res_letterbox.model_id<br>- res_letterbox.priority<br>- res_letterbox.destination<br>- res_letterbox.type_id                           | SELECT<br>  creation_date AS "time",<br>  res_id AS "type de courriers"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date) <br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>GROUP BY creation_date, res_id<br>ORDER BY 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| Nombre de courriers total des statuts sélectionnés      | - res_letterbox.model_id<br>- res_letterbox.priority<br>- res_letterbox.destination<br>- res_letterbox.type_id<br>- res_letterbox.status | SELECT<br>   creation_date AS "time",<br>  res_id AS "Nombre de courriers :  $Statuts"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date) <br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND res_letterbox.status IN (SELECT id FROM status WHERE label_status IN ($Statuts))<br>GROUP BY 1,res_id<br>ORDER BY 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| Nombre de courriers clôturés                            | res_letterbox.status                                                                                                                     | voir filtre par statut                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| Délai moyen de clôture                                  | - res_letterbox.creation_date<br>- res_letterbox.closing_date<br>- res_letterbox.status                                                  | SELECT<br>  creation_date AS "time",closing_date,<br>  (Date(closing_date) - Date(creation_date)+1) AS "Délais Moyen de traitement"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>GROUP BY creation_date,closing_date<br>ORDER BY 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| Délai moyen de traitement des courriers en cours        | - res_letterbox.creation_date<br>- res_letterbox.process_limit_date (!)<br>- res_letterbox.status                                        | SELECT<br>  creation_date AS "time",<br>  (Date(process_limit_date) - Date(creation_date)+1) AS "Délais Moyen de traitement"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND status NOT IN ('END','DEL')<br>  AND process_limit_date IS NOT NULL<br>GROUP BY creation_date,process_limit_date                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| Délai moyen d’envoi d’AR                                | - res_letterbox.res_id<br>- res_letterbox.creation_date<br>- acknowledgement_receipts.send_date                                          | SELECT<br>  --res_letterbox.creation_date AS "time",<br>  (Date(acknowledgement_receipts.send_date) - Date(res_letterbox.creation_date)+1) AS "Délais Moyen de traitement"<br>FROM res_letterbox, acknowledgement_receipts<br>WHERE<br>  $__timeFilter(res_letterbox.creation_date)<br>  AND res_letterbox.destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND category_id='incoming'<br>  AND acknowledgement_receipts.res_id = res_letterbox.res_id<br>GROUP BY res_letterbox.creation_date,acknowledgement_receipts.send_date<br>--ORDER BY 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| Nombre de courriers en retard                           | - res_letterbox.res_id<br>- res_letterbox.creation_date<br>- acknowledgement_receipts.send_date                                          | SSELECT<br>    count( res_id) AS "Courrier en retard"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND status NOT IN ('DEL','END')<br>  AND (now() > process_limit_date)<br>  --AND process_limit_date IS NOT NULL                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| Nombre de courriers dans les délais                     | - res_letterbox.res_id<br>- res_letterbox.creation_date<br>- acknowledgement_receipts.send_date                                          | SELECT<br>  count( res_id)  AS "Courriers dans le délais"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND status NOT IN ('DEL','END')<br>  AND (now() < process_limit_date)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| Nombre total d’AR envoyés                               | - res_letterbox.res_id<br>- res_letterbox.creation_date<br>- acknowledgement_receipts.send_date                                          | SELECT<br>  count(res_letterbox.res_id) AS "Nombre Total d'AR "<br>FROM res_letterbox, acknowledgement_receipts<br>WHERE<br>  $__timeFilter(res_letterbox.creation_date)<br>  AND res_letterbox.destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND category_id='incoming'<br>  AND acknowledgement_receipts.res_id = res_letterbox.res_id                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| Nombre total d’AR envoyés dans le délais                | - res_letterbox.res_id<br>- res_letterbox.creation_date<br>- acknowledgement_receipts.send_date                                          | SELECT<br>  count(res_letterbox.res_id) AS "Nombre d'AR dans le délais"<br>FROM res_letterbox, acknowledgement_receipts<br>WHERE<br>  $__timeFilter(res_letterbox.creation_date)<br>  AND res_letterbox.destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND category_id='incoming'<br>  AND acknowledgement_receipts.res_id = res_letterbox.res_id<br>  AND  Date(acknowledgement_receipts.send_date) +1 > Date(res_letterbox.admission_date)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| Nombre total d’AR en retard                             | - res_letterbox.res_id<br>- res_letterbox.creation_date<br>- acknowledgement_receipts.send_date                                          | SELECT<br>  count(res_letterbox.res_id) AS "Nombre d'AR en retard"<br>FROM res_letterbox, acknowledgement_receipts<br>WHERE<br>  $__timeFilter(res_letterbox.creation_date)<br>  AND res_letterbox.destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND category_id='incoming'<br>  AND acknowledgement_receipts.res_id = res_letterbox.res_id<br>  AND  Date(acknowledgement_receipts.send_date) +1 < Date(res_letterbox.admission_date)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| Pourcentage d’AR envoyés dans les délais                | - res_letterbox.res_id<br>- res_letterbox.creation_date<br>- acknowledgement_receipts.send_date                                          | SELECT<br>   ($pct_AR ) As "% d'AR dans le delais"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>GROUP BY creation_date,admission_date                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| Nombre de courriers par jour                            | - res_letterbox.res_id<br>- res_letterbox.creation_date                                                                                  | SELECT<br>  $__timeGroup(creation_date,1d) AS "time",<br>  count(res_id) AS "Nombre de courriers reçus par jours"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>GROUP BY 1<br>order by 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| Nombre de courriers en Retard / dans le délais par jour |                                                                                                                                          | SELECT<br>  $__timeGroup(creation_date,1d) AS "time",<br>  count(res_id) AS "Courrier dans le délais"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND status NOT IN ('DEL','REP')<br>  AND (now() < process_limit_date)<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>GROUP BY 1<br>order by 1<br><br>_______________________________________________________<br><br><br>SELECT<br>  $__timeGroup(creation_date,1d) AS "time",<br>  count(res_id) AS "Courrier en retard"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND status NOT IN ('DEL','REP')<br>  AND (now() > process_limit_date)<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>GROUP BY 1<br>order by 1<br><br>____________________________________<br><br>( à mettre dans le même panel )                                                                                                                                                                                                                               |
| Délais d'envoi de AR par jour                           |                                                                                                                                          | SELECT<br>   $__timeGroup(res_letterbox.creation_date,1d) AS "time",<br>  (Date(acknowledgement_receipts.send_date) - Date(res_letterbox.creation_date)+1) AS "Délais d'envoi d'AR"<br>FROM res_letterbox, acknowledgement_receipts<br>WHERE<br>  $__timeFilter(res_letterbox.creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND acknowledgement_receipts.res_id = res_letterbox.res_id<br>  AND category_id='incoming'<br>GROUP BY res_letterbox.creation_date, acknowledgement_receipts.send_date<br>--ORDER BY 1<br><br>_____________________________________________________________<br>SELECT<br>  creation_date AS "time",<br>  $delais_AR AS "Délais Moyen d'envoi de AR : $delais_AR"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>GROUP BY creation_date,admission_date<br>___________________________________________________________<br>( à mettre dans le même panel ) |
| Délais de traitement par jour                           |                                                                                                                                          | SELECT<br>  $__timeGroup(creation_date,1d) AS"time",<br>  (Date(process_limit_date) - Date(creation_date)) AS "Délais de traitement"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND status NOT IN ('END','DEL')<br>GROUP BY creation_date,closing_date,process_limit_date<br>ORDER BY 1<br><br>_________________________________________________________<br><br>SELECT<br>  $__timeGroup(creation_date,1d) AS"time",<br>  $delais_moyen_traitement AS "Délais Moyen de traitement : $delais_moyen_traitement"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(process_limit_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND status NOT IN ('END','DEL')<br>GROUP BY creation_date,closing_date<br>ORDER BY 1                                                                              |
| Délais de clôture par jour                              |                                                                                                                                          | SELECT<br>  $__timeGroup(res_letterbox.creation_date,1d) AS "time",<br>  (Date(closing_date) - Date(creation_date)) AS "Délais de clôture"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND model_id IN (SELECT id FROM indexing_models WHERE label IN ($model_label))<br>  AND priority IN (SELECT id FROM priorities WHERE label IN ($priority_label))<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND status='END'<br>GROUP BY creation_date,closing_date<br>--ORDER BY 1<br><br>________________________________________________________________________<br><br>SELECT<br>  creation_date AS "time",<br>  $delais_moyen_cloture AS "Délais Moyen de clôture : $delais_moyen_cloture"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND status='END'<br>GROUP BY creation_date,closing_date                                                                                                                                                                                                                                                                                                                                                                                                                   |




* Liste des variables

| **Variables**           | **Description**                    | **Requêtes SQL associées**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
|-------------------------|------------------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| entity_label            | Liste des labels des entités       | SELECT entity_label FROM entities                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| model_label             | Liste des labels des modèles       | SELECT label FROM indexing_models                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| priority_label          | Liste des labels des priorités     | SELECT label FROM priorities                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| Entities                | Identifiants des entités           | SELECT entity_id FROM entities WHERE entity_label IN ($entity_label)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| type_description        | description des types de courriers | SELECT description FROM doctypes                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| Statuts                 | liste des statuts des courriers    | SELECT label_status  FROM status                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| nb_AR_dans_delais       | Nombre d’AR dans le délais         | SELECT<br>  count(res_letterbox.res_id)<br>FROM res_letterbox, acknowledgement_receipts<br>WHERE<br>  $__timeFilter(res_letterbox.creation_date)<br>  AND res_letterbox.destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND category_id='incoming'<br>  AND acknowledgement_receipts.res_id = res_letterbox.res_id<br>  AND  Date(acknowledgement_receipts.send_date) +1 > Date(res_letterbox.admission_date) |
| all_AR                  | Nombre total d’AR                  | SELECT<br>  count(res_letterbox.res_id)<br>FROM res_letterbox, acknowledgement_receipts<br>WHERE<br>  $__timeFilter(res_letterbox.creation_date)<br>  AND res_letterbox.destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND res_letterbox.type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND category_id='incoming'<br>  AND acknowledgement_receipts.res_id = res_letterbox.res_id                                                                                            |
| pct_AR                  | Pourcentage d’AR dans le déliais   | SELECT<br>  (cast($nb_AR_dans_delais as decimal)*100  / $all_AR) As "Nombre total d'AR"<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))                                                                                                                            |
| delais_moyen_cloture    |                                    | SELECT<br>  avg(Date(closing_date) - Date(creation_date)+1)<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND category_id='incoming'                                                                                                                        |
| delais_moyen_traitement |                                    | SELECT<br>  avg(Date(process_limit_date) - Date(creation_date)+1)<br>FROM res_letterbox<br>WHERE<br>  $__timeFilter(creation_date)<br>  AND type_id IN (SELECT type_id FROM doctypes WHERE description IN ($type_description))<br>  AND status IN (SELECT id  FROM status WHERE status.label_status IN ($Statuts))<br>  AND destination IN ( SELECT entity_id FROM entities WHERE entity_id IN ($Entities))<br>  AND category_id='incoming'                                                                                                                  |

