# Tâches planifiées

/etc/crontab
/etc/cron

/var/spool/cron/crontabs   les users de crontab

```
root@MaarchIntegration1904:/var/spool/cron/crontabs# ls -ltr
total 40
-rw------- 1 www-data crontab   201 avril 20  2018 www-data
-rw------- 1 maarch   crontab 33491 août   6 15:17 maarch
```

ne pas lancer les tâches en root mais bien vérifier qu'elle s'execute avec l'utilisateur maarch

## Afficher et éditer la contab

Pour afficher le contenu de votre crontab :

```
crontab -l
```

La crontab affichée est celle de l'utilisateur (maarch, root..), l'option -e permet d'éditer la crontab et l'option -u permet d'afficher la crontab de l'utilisateur spécifié

```
maarch@MaarchIntegration1810:/var/www/html/MaarchCourrier$ crontab -e

maarch@MaarchIntegration1810:/var/www/html/MaarchCourrier$ crontab -e -u maarch
```

La crontab regroupe les tâches planifiées par sections :

Si le dsyfonctionnement concerne une section donnée il faut :

- vérifier que la ligne n'est pas commentée,
- vérifier le script concerné

Exemple :

```bash
######################notification#################################################

15 10 * * *     /var/www/html/MaarchCourrier/custom/cs_A/modules/notifications/batch/scripts/nct-ncc-and-anc.sh
15 15 * * *     /var/www/html/MaarchCourrier/custom/cs_A/modules/notifications/batch/scripts/nct-ncc-and-anc.sh
15 12 * * *     /var/www/html/MaarchCourrier/custom/cs_A/modules/notifications/batch/scripts/nct-ncc-and-anc.sh

30 10 * * *     /var/www/html/MaarchCourrier/custom/cs_A/modules/notifications/batch/scripts/sendmail.sh
30 15 * * *     /var/www/html/MaarchCourrier/custom/cs_A/modules/notifications/batch/scripts/sendmail.sh
30 12 * * *     /var/www/html/MaarchCourrier/custom/cs_A/modules/notifications/batch/scripts/sendmail.sh

10 12 * * 0     rm -Rf /var/www/html/MaarchCourrier/modules/notifications/batch/logs/process_event_stack/*.log
11 12 * * 0     rm -Rf /var/www/html/MaarchCourrier/modules/notifications/batch/logs/process_email_stack/*.log

######################sendmail####################################################

*/2 * * * *    /var/www/html/MaarchCourrier/custom/cs_A/modules/sendmail/batch/scripts/sendmail.sh >/dev/null 2>&1
0 12 * * 0     rm -Rf /var/www/html/MaarchCourrier/modules/sendmail/batch/logs/*.log

######################fulltext###################################################

*/5 5-21 * * 1-5   /var/www/html/MaarchCourrier/custom/cs_A/modules/full_text/scripts/launch_fulltext.sh
20 12 * * 0        rm -Rf /var/www/html/MaarchCourrier/modules/full_text/log/*.log
```

Si le dysfonctionnement concerne une saturation de l'espace par les logs, il est recommandé d'ajouter des tâches planifiées de purges :

https://docs.maarch.org/gitbook/html/MaarchCourrier/19.04/guat/guat_exploitation/purge.html

Pour choisir les fréquences de l'execution des tâches planifiées, il existe un grand nombre de générateur de crontab (exemple : https://crontab-generator.org/ )

## Activer et désactiver la crontab

Pour activer et suspendre les tâches planifiées:

- Debian/ubuntu/linux
  - service cron status
  - service cron stop
  - service cron start


- RHEL/CentOS/Fedora
- 
  - service crond status
  - service crond stop
  - service crond start

```
root@se-mar-maarch18:/var/www/html/MaarchCourrierProduction/modules/notifications/batch/logs/basket_event_stack# service cron status
● cron.service - Regular background program processing daemon
   Loaded: loaded (/lib/systemd/system/cron.service; enabled; vendor preset: enabled)
   Active: active (running) since Thu 2019-07-04 11:35:51 CEST; 2 months 15 days ago
     Docs: man:cron(8)
 Main PID: 608 (cron)
    Tasks: 1 (limit: 4915)
   CGroup: /system.slice/cron.service
           └─608 /usr/sbin/cron -f

```

